conn(I,J,V) :- link(I,J,V), not stuck(V).

reach(I,0)   :- full(I).
reach(I,N+1) :- reach(J,N), conn(J,I,V), step(N).

done(I,N)   :- goal(I), reach(I,N).
done(I,N+1) :- step(N), done(I,N).

existundone(N) :- goal(I), step(N), not done(I,N).
alldone(N) :- step(N), not existundone(N).
alldone(N+1) :- step(N), not existundone(N+1).
alldone      :- alldone(N).
:- not alldone.

step(0..S-1) :- S = { switchon(V,N) : switchon(V,N) }.
 :- step(N), not 1 { switchon(V,N) : switchon(V,N) } 1.
% :- switchon(V,N), not step(N).
 :- switchon(V,N), not valve(V).
 :- switchon(V,N), stuck(V).
% :- switchon(V,N), alldone(N).

follow(I,0)   :- full(I).
follow(I,N+1) :- follow(J,N), link(J,I,V), switchon(V,N).
% :- switchon(V,N), not follow(J,N) : link(J,I,V).

% with the following rule it seems work
% :- goal(I), step(N), not step(N+1), not follow(I,N+1).

%#hide.
%#show switchon(V,N).
